using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

using CanAerospaceCore;
using FTD2XX_NET;
using System.Threading;

namespace WindowsFormsApplication2.AK103
{
    public partial class AK103Form : Form
    {
        public AK103Form()
        {
            InitializeComponent();
        }

        private void AK103Form_FormClosing(object sender, FormClosingEventArgs e)
        {
            Properties.Settings.Default.AK103_FormLocation = Location;
            Properties.Settings.Default.Save();
        }

        private void AK103Form_Load(object sender, EventArgs e)
        {
            StartPosition = FormStartPosition.Manual;
            Location = Properties.Settings.Default.AK103_FormLocation;
        }

        private void AK103_refresh_Click(object sender, EventArgs e)
        {
            Form1 mainform = Application.OpenForms.OfType<Form1>().First();
            mainform.ActiveForm2 = null;
            this.Close();
        }

        private void AK103_button_click(object sender, EventArgs e)
        {
            if (Application.OpenForms.OfType<Form1>().Any())
            {
                Form1 mainform = Application.OpenForms.OfType<Form1>().First();
                if (mainform.ActiveForm2 != null)
                {
                    Button button = sender as Button;
                    uint weaponChannel = 100;
                    byte weaponNodeId = 139;
                    CanData dataToWrite = new CanData();
                    //Thread.Sleep(1000);
                    byte register = 10;
                    switch (button.Name)
                    {
                        case ("AK103_shot"):
                            dataToWrite.SetAsUchar((byte)(16));
                            break;
                        default:
                            return;
                        //break;
                    }
                    RegisterKey regKey = new RegisterKey(weaponNodeId, register);
                    mainform.canConnection.SendRegisterWriteRequest(weaponChannel, regKey, dataToWrite);
                }

            }

        }

        public void AK103_numericUpDown_ValueChanged(object sender, EventArgs e)
        {
            NumericUpDown editbox = sender as NumericUpDown;
            uint weaponChannel = 100;
            byte weaponNodeId = 139;
            CanData dataToWrite = new CanData();
            //Thread.Sleep(1000);

            byte register = 0;
            switch (editbox.Name)
            {
                case ("AK103_treshlow"):
                    register = 29;
                    dataToWrite.SetAsUchar((byte)(editbox.Value));
                    break;
                case ("AK103_treshhigh"):
                    register = 30;
                    dataToWrite.SetAsUchar((byte)(editbox.Value));
                    break;
                case ("AK103_voltoffset"):
                    register = 33;
                    dataToWrite.SetAsShort((short)(editbox.Value));
                    break;
                case ("AK103_dagain"):
                    register = 34;
                    dataToWrite.SetAsShort((short)(editbox.Value));
                    break;
                case ("AK103_rs100m"):
                    register = 100;
                    dataToWrite.SetAsShort((short)(editbox.Value));
                    break;
                case ("AK103_rs200m"):
                    register = 101;
                    dataToWrite.SetAsShort((short)(editbox.Value));
                    break;
                case ("AK103_rs300m"):
                    register = 102;
                    dataToWrite.SetAsShort((short)(editbox.Value));
                    break;
                case ("AK103_rs400m"):
                    register = 103;
                    dataToWrite.SetAsShort((short)(editbox.Value));
                    break;
                case ("AK103_rs500m"):
                    register = 104;
                    dataToWrite.SetAsShort((short)(editbox.Value));
                    break;
                case ("AK103_rs600m"):
                    register = 105;
                    dataToWrite.SetAsShort((short)(editbox.Value));
                    break;
                case ("AK103_rs700m"):
                    register = 106;
                    dataToWrite.SetAsShort((short)(editbox.Value));
                    break;
                case ("AK103_rs800m"):
                    register = 107;
                    dataToWrite.SetAsShort((short)(editbox.Value));
                    break;
                default:
                    return;
                //break;
            }
            if (register == 0) return;
            if (Application.OpenForms.OfType<Form1>().Any())
            {
                Form1 mainform = Application.OpenForms.OfType<Form1>().First();
                if (mainform.ActiveForm2 != null)
                {
                    RegisterKey regKey = new RegisterKey(weaponNodeId, register);
                    if (mainform.canConnection.SendRegisterWriteRequest(weaponChannel, regKey, dataToWrite)) MessageBox.Show("Value changed");
                }

            }

        }


    }
}
